daz	proc	near
;
;This function prints an ASCIIZ string to the monochrome screen.
;First push the seg and offset of the asciiz string onto the
;stack, then push the line number and finally the starting
;screen column for the display. Call daz and then adjust the
;stack as shown below.  Requires d2_asc.inc to run.
;
;	push	segment string
;	push	offset string
;	push	line number
;	push	starting column number
;	call	daz
;	add	sp,8	;fix stack
;
;           written by
;      John O. Battle, N4OE
;         c/s 73547,3346
;    732A Holcomb Bridge Road
;       Norcross, GA 30071
;         (404) 449-8536
;
column	dw	?
line	dw	?
	push	ds		;10 pushes in all
	push	es
	push	ax
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	bp
	pushf

	mov	bp,sp		;get args from stack
	mov	ax,[bp+22]	;arg 1 (2*10 pushes + 2*1)
	mov	column,ax	;screen column number
	mov	ax,[bp+24]	;arg 2 (2*10 pushes + 2*2)
	mov	line,ax  	;screen line number
	mov	di,[bp+26]	;arg 3 (2*10 pushes + 2*3)
				;offset of string
	mov	ax,[bp+28]	;arg 3 (2*10 pushes + 2*4)
	mov	es,ax		;segment of string
daz_1:
	mov	ax,es:[di]
	cmp	al,0
	je	daz_2
	push	ax
	push	column
	push	line
	call	d2_asc
	add	sp,6
	inc	di
	inc	column
	loop	daz_1
daz_2:
	popf
	pop	bp
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	pop	es
	pop	ds
	ret
daz	endp
